'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactLive = require('react-live');

var _theme = require('@storybook/components/dist/theme');

var _constants = require('../constants');

var _Style = require('babel-loader!react-live/src/components/Editor/Style');

var _Style2 = _interopRequireDefault(_Style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// $FlowIgnore


var LiveEditor = function (_React$Component) {
    _inherits(LiveEditor, _React$Component);

    function LiveEditor() {
        var _ref;

        _classCallCheck(this, LiveEditor);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        // $FlowIgnore
        var _this = _possibleConstructorReturn(this, (_ref = LiveEditor.__proto__ || Object.getPrototypeOf(LiveEditor)).call.apply(_ref, [this].concat(_toConsumableArray(args))));

        _this.state = {
            code: null
        };
        _this.loadSource = _this.loadSource.bind(_this);
        // $FlowIgnore
        _this.onSourceChange = _this.onSourceChange.bind(_this);
        return _this;
    }

    _createClass(LiveEditor, [{
        key: 'loadSource',
        value: function loadSource(code) {
            this.setState({ code: code });
        }
    }, {
        key: 'onSourceChange',
        value: function onSourceChange(code) {
            this.props.channel.emit(_constants.event.UpdateSource, code);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.channel.on(_constants.event.LoadSource, this.loadSource);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.props.channel.removeListener(_constants.event.LoadSource, this.loadSource);
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.state.code === null) {
                return React.createElement(
                    'div',
                    {
                        style: _extends({}, _theme.baseFonts, {
                            width: '100%',
                            textAlign: 'center',
                            padding: '20px',
                            color: 'gray',
                            textTransform: 'uppercase'
                        })
                    },
                    'Editor unavailable'
                );
            }

            return React.createElement(
                'div',
                { style: { width: '100%', height: '100%' } },
                React.createElement(_Style2.default, null),
                React.createElement(_reactLive.Editor, { onChange: this.onSourceChange, code: this.state.code, style: { height: '100%' } })
            );
        }
    }]);

    return LiveEditor;
}(React.Component);

exports.default = LiveEditor;
//# sourceMappingURL=LiveEditor.js.map