'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.cleanupError = undefined;

var _constants = require('./constants');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

exports.default = function (code) {
    return 'const thunk = (render) => {\n' + code + '\n};\n    \n    let renderWasCalled = false;\n    \n    const renderWithCheck = (element) => {\n        renderWasCalled = true;\n        render(element);\n    };\n    \n    const result = thunk(renderWithCheck);\n    \n    if (!renderWasCalled) {\n        if (React.isValidElement(result)) {\n            render(result);\n        } else {\n            render(<div className="' + _constants.className.error + '">Code should return a valid react element or call \'render(element)\'!</div>);\n        }\n    }\n';
};

var safeSubtractFromString = function safeSubtractFromString(a, b) {
    return String(Math.max(Number(a) - b, 0));
};

var cleanupError = exports.cleanupError = function cleanupError(error) {
    var linesToRemove = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

    var _error$split = error.split('\n'),
        _error$split2 = _toArray(_error$split),
        dirtyHeader = _error$split2[0],
        dirtyLines = _error$split2.slice(1);

    var subtractLineNumber = function subtractLineNumber(match, line) {
        return match.replace(line, safeSubtractFromString(line, linesToRemove));
    };

    var header = dirtyHeader.replace(/\(([0-9]+):[0-9]+\)$/, subtractLineNumber);

    var lines = dirtyLines.map(function (line) {
        return line.replace(/^([0-9]+)\s*:/, subtractLineNumber);
    }).filter(function (line) {
        return !line.match(/^\s*0+\s*:/);
    });

    return [header].concat(_toConsumableArray(lines)).join('\n');
};
//# sourceMappingURL=returnToRender.js.map